


// Name
//===================================
//
// BlockType
//

#ifndef BLOCK_TYPE_H
#define BLOCK_TYPE_H


// FORWARD DECLARATIONS
//===================================

    class Block;
    class Collision;
    class Sprite;
    class SpriteGraphics;


// DEPENDENCIES
//===================================

    #include "object.h"


// CLASS
//===================================

    class BlockType
    {
        public:
            enum BlockAction
            {
                __NULL,
                SOLID,
                FLAT_TOP,
                CLIMBABLE,
                GEM,
                HURT,
                GOAL
            };

            BlockType
            (
                SpriteGraphics* g1 = nullptr,
                SpriteGraphics* g2 = nullptr,
                SpriteGraphics* g3 = nullptr,
                SpriteGraphics* g4 = nullptr,
                BlockAction action = BlockAction::__NULL
            );
            ~BlockType();

            void collide( Sprite& sprite, Collision& collision );
            void render( Graphics& graphics, Camera& camera, Block& block );
            const BlockAction action() const;

        private:
            static const int BLOCK_SIZE = 16;
            static const int MINI_BLOCK_SIZE = 8;
            static const int NUM_O_MINI_BLOCKS = 4;

            SpriteGraphics* graphics_[ NUM_O_MINI_BLOCKS ] = { nullptr };
            const BlockAction action_;
    };

#endif // BLOCK_TYPE_H
