


// Name
//===================================
//
// Inventory
//

#ifndef INVENTORY_H
#define INVENTORY_H


// FORWARD DECLARATIONS
//===================================

    class Graphics;


// DEPENDENCIES
//===================================

    #include "sprite_graphics.h"
    #include "text.h"
    #include "unit.h"


// CLASS
//===================================

    class Inventory
    {
        public:
            Inventory();
            ~Inventory();

            void render( Graphics& graphics );
            void reset();

            void addFunds( int n = 1 );
            int funds() const;
            void loseHeart( int n = 1 );
            int hearts() const;

        private:
            const int HEARTS_MAX = 3;
            const int FUNDS_MAX = 999;
            int funds_ = 0;
            int hearts_ = 3;

            SpriteGraphics gem_icon_gfx_ = SpriteGraphics( Graphics::SpriteSheet::LVTILESET_UNIVERSAL );
            SDL_Rect gem_icon_pos_ = { 8, Unit::WINDOW_HEIGHT_PIXELS - 24, 16, 16 };
            SpriteGraphics heart_icon_gfx_ = SpriteGraphics( Graphics::SpriteSheet::LVTILESET_UNIVERSAL, 16 );
            SDL_Rect heart_icon_pos_ = { 64, Unit::WINDOW_HEIGHT_PIXELS - 24, 16, 16 };
            Text funds_string_ = Text( "DEMO", 28, Unit::WINDOW_HEIGHT_PIXELS - 20 );
    };

#endif // INVENTORY_H

