

// Name
//===================================
//
// Map
//

#ifndef MAP_H
#define MAP_H


// FORWARD DECLARATIONS
//===================================


// DEPENDENCIES
//===================================

    #include <vector>


// CLASS
//===================================

    class Map
    {
        public:
            Map
            (
            );
            ~Map();

            int widthBlocks() const;
            int heightBlocks() const;
            int widthPixels() const;
            int heightPixels() const;
            int blocksSize() const;
            int block( int n ) const;
            int mapX( int n ) const;
            int mapY( int n ) const;
            const bool changed() const;
            void changeBlock( int where, int value );
            void deleteBlock( int where );
            void update();

        private:
            std::vector<int> blocks_;
            int width_ = 224;
            int height_ = 16;
            bool changed_ = false;

            bool inBounds( int n ) const;
    };

#endif // MAP_H
