

// Name
//===================================
//
// PlayerMovement
//

#ifndef PLAYER_MOVEMENT_H
#define PLAYER_MOVEMENT_H


// FORWARD DECLARATIONS
//===================================

    class Block;
    class Input;
    class Sprite;


// DEPENDENCIES
//===================================

    #include "sprite_movement.h"
    #include "timers/timer_simple.h"


// CLASS
//===================================

    class PlayerMovement : public SpriteMovement
    {
        public:
            ~PlayerMovement();
            void update( Sprite& sprite, Input& input, Camera& camera, Map& lvmap, SpriteGraphics* graphics );
            void collision( Collision collision, Sprite& sprite, Sprite& other );
            void collision( Collision collision, Sprite& sprite, Block& block, Map& lvmap, EventSystem& events, Inventory& inventory );

        private:
            bool collide_top_ = false;
            bool collide_bottom_ = false;
            bool collide_top_prev_ = false;
            bool collide_bottom_prev_ = false;
            bool touching_ladder_ = false;
            bool touching_ladder_prev_ = false;

            const int HP_MAX = 3;
            int hp_ = 3;

            bool invincible_ = false;
            TimerSimple invincibility_timer_ = TimerSimple( 48, false );

            void hurt( Sprite& sprite, Inventory& inventory );
    };


#endif // PLAYER_MOVEMENT_H
