
// Name
//===================================
//
// SpriteMovement
//

#ifndef SPRITE_MOVEMENT_H
#define SPRITE_MOVEMENT_H


// FORWARD DECLARATIONS
//===================================

    class Block;
    class Camera;
    class EventSystem;
    class Inventory;
    class Map;
    class SpriteGraphics;


// DEPENDENCIES
//===================================

    class Collision;
    class Input;
    class Sprite;


// CLASS
//===================================

    class SpriteMovement
    {
        public:
            virtual ~SpriteMovement();
            virtual void update( Sprite& sprite, Input& input, Camera& camera, Map& lvmap, SpriteGraphics* graphics ) = 0;
            virtual void collision( Collision collision, Sprite& sprite, Sprite& other ) = 0;
            virtual void collision( Collision collision, Sprite& sprite, Block& block, Map& lvmap, EventSystem& events, Inventory& inventory ) = 0;
    };


#endif // SPRITE_MOVEMENT_H
