




// Name
//===================================
//
// Text
//


// DEPENDENCIES
//===================================

    #include "graphics.h"
    #include "text.h"


// STATIC PROPERTIES
//===================================

// METHODS
//===================================

    Text::Text
    (
        std::string words,
        int x,
        int y
    )
    :
        words_ ( words ),
        x_ ( x ),
        y_ ( y ),
        rect_ ( { x, y, 8, 8 } )
    {};

    Text::~Text() {};

    void Text::render( Graphics& graphics, Camera* camera )
    {
        graphics.renderObject( Graphics::SpriteSheet::CHARSET, {0,0,8,8}, rect_ );
    };

    void Text::renderNumber( Graphics& graphics, int n, int digits, Camera* camera )
    {
        int nDigits = numODigits( n );

        if ( digits < 1 )
        {
            digits = nDigits;
        }

        for ( int i = digits; i > 0; --i )
        {
            int d = 0;

            if ( i <= nDigits )
            {
                d = getDigit( n, i );
            }

            graphics.renderObject( Graphics::SpriteSheet::CHARSET, {8 * d,0,8,8}, rect_ );
            rect_.x += 8;
        }
        rect_.x = x_;
    };

    int Text::getDigit( int n, int d, int remain ) const
    {
        return int( floor( n / pow( 10, d-1 ) ) ) % remain;
    };

    int Text::numODigits( int n ) const
    {
        if ( n == 0 )
        {
            return 1;
        }
        else
        {
            for ( int i = 0; i < 99; ++i )
            {
                if ( abs( n ) < pow( 10, i ) )
                {
                    return i;
                }
            }
        }

        return -1;
    };
