



// Name
//===================================
//
// Text
//

#ifndef TEXT_H
#define TEXT_H


// FORWARD DECLARATIONS
//===================================

    class Camera;
    class Graphics;


// DEPENDENCIES
//===================================

    #include <SDL2/SDL.h>
    #include <string>


// CLASS
//===================================

    class Text
    {
        public:
            Text
            (
                std::string words,
                int x = 0,
                int y = 0
            );
            ~Text();
            void render( Graphics& graphics, Camera* camera = nullptr );
            void renderNumber( Graphics& graphics, int n, int digits = -1, Camera* camera = nullptr );

        private:
            std::string words_;
            int x_ = 0;
            int y_ = 0;
            SDL_Rect rect_ = { 0, 0, 8, 8 };
            int getDigit( int n, int d, int remain = 10 ) const;
            int numODigits( int n ) const;
    };

#endif // TEXT_H

